From 6489dd348f7f292bb99f7f71dae39b14f2858c41 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:11 +0000
Subject: [PATCH 740/1001] Make a real class for WidgetParameter


---

diff --git a/hubs/models.py b/hubs/models.py
index d322437..2c155b9 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -296,7 +296,7 @@ def _config_default(context):
     widget_name = context.current_parameters['plugin']
     widget = hubs.widgets.registry[widget_name]
     return json.dumps(dict([
-        (arg.name, arg.default) for arg in widget.get_arguments()
+        (param.name, param.default) for param in widget.get_parameters()
         ]))
 
 
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 27e9235..6641711 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -204,16 +204,16 @@ def hub_add_widget_post(name):
         plugin=widget_name, index=-1, left=position == 'left')
     error = False
     config = {}
-    for arg in widget.module.get_arguments():
-        val = flask.request.form.get(arg.name)
+    for param in widget.module.get_parameters():
+        val = flask.request.form.get(param.name)
         if not val:
             flask.flash(
-                'You must provide a value for: %s' % arg.name, 'error')
+                'You must provide a value for: %s' % param.name, 'error')
             error = True
             break
         try:
-            arg.validator(flask.g.db, val)
-            config[arg.name] = val
+            param.validator(flask.g.db, val)
+            config[param.name] = val
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
             error = True
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index cbc002c..192c44d 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -40,16 +40,16 @@ def widget_edit_post(hub, idx):
     widget = get_widget_instance(hub, idx)
     error = False
     config = {}
-    for arg in widget.module.get_arguments():
-        val = flask.request.form.get(arg.name)
+    for param in widget.module.get_parameters():
+        val = flask.request.form.get(param.name)
         if not val:
             flask.flash(
-                'You must provide a value for: %s' % arg.name, 'error')
+                'You must provide a value for: %s' % param.name, 'error')
             error = True
             break
         try:
-            val = arg.validator(flask.g.db, val)
-            config[arg.name] = val
+            val = param.validator(flask.g.db, val)
+            config[param.name] = val
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
             error = True
diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index 1a8cc50..bdb7e7b 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -9,7 +9,7 @@ class About(Widget):
 
     name = "about"
     position = "both"
-    arguments = [dict(
+    parameters = [dict(
         name="text",
         label="Text",
         default="I am a Fedora user, and this is my about",
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index 6c76716..79315e1 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -12,7 +12,7 @@ class Badges(Widget):
 
     name = "badges"
     position = "right"
-    arguments = [dict(
+    parameters = [dict(
         name="username",
         label="Username",
         default=None,
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 70dbc9c..50b726e 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,6 +1,5 @@
 from __future__ import unicode_literals, absolute_import
 
-import collections
 import logging
 import re
 import flask
@@ -14,8 +13,33 @@ from .view import WidgetView
 
 log = logging.getLogger(__name__)
 
-Argument = collections.namedtuple(
-    'Argument', ('name', 'label', 'default', 'validator', 'help'))
+
+class WidgetParameter(object):
+    """
+    Configuration option for a widget.
+
+    A widget can be configured differently for each instance of this widget in
+    a hub.  The list of configuration options is described by the list of
+    :py:class:`WidgetParameter` objects returned by the widget's
+    :py:meth:`~Widget.get_parameters` method.
+
+    Attributes:
+        name (str): The name of the parameter.
+        label (str): A humanized name of the parameter, which will be shown in
+            the UI.
+        default: The default value if this parameter is not set.
+        validator (function): A validation function that will be called when
+            a user sets the parameter value.
+        help (str): A help text that will be shown in the UI.
+    """
+
+    _attrs = ('name', 'label', 'default', 'validator', 'help')
+
+    def __init__(self, **kwargs):
+        for name in self._attrs:
+            setattr(self, name, kwargs.pop(name, None))
+        for name in kwargs:
+            raise TypeError("Invalid attribute: %s" % name)
 
 
 class Widget(object):
@@ -29,13 +53,13 @@ class Widget(object):
         position (str): The position of the widget in the rendered page. It
             should be one of the following values: ``left``, ``right``, or
             ``both``.
-        arguments (list): A list of dictionaries that describe a widget's
-            configuration. See :py:class:`hubs.widgets.base.Argument`.
+        parameters (list): A list of dictionaries that describe a widget's
+            configuration. See :py:class:`hubs.widgets.base.WidgetParameter`.
     """
 
     name = None
     position = None
-    arguments = []
+    parameters = []
 
     def __init__(self):
         self._template_environment = None
@@ -65,8 +89,12 @@ class Widget(object):
             raise AttributeError(
                 'The root view must be registered for the "/" URL rule.')
 
-    def get_arguments(self):
-        return [Argument(**arg) for arg in self.arguments]
+    def get_parameters(self):
+        """
+        Return the :py:class:`WidgetParameter` instances that describe this
+        widget's configuration options.
+        """
+        return [WidgetParameter(**param) for param in self.parameters]
 
     def get_template_environment(self):
         """
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 5965be1..c63fa3c 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -15,7 +15,7 @@ class Bugzilla(Widget):
 
     name = "bugzilla"
     position = "right"
-    arguments = [dict(
+    parameters = [dict(
         name="username",
         label="Username",
         default=None,
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index 19d43c4..ca4bac8 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -8,7 +8,7 @@ class Dummy(Widget):
 
     name = "dummy"
     position = "both"
-    arguments = [dict(
+    parameters = [dict(
         name="text",
         label="Text",
         default="Lorem ipsum dolor...",
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index a557148..142548f 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -17,7 +17,7 @@ class FedmsgStats(Widget):
 
     name = "fedmsgstats"
     position = "both"
-    arguments = [dict(
+    parameters = [dict(
         name="username",
         label="Username",
         default=None,
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index bd35b61..b1f8299 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -12,7 +12,7 @@ class Feed(Widget):
 
     name = "feed"
     position = "left"
-    arguments = [
+    parameters = [
         {
             "name": "username",
             "label": "Username",
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index 2c9d26c..8f60efa 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -11,7 +11,7 @@ class FedoraHosted(Widget):
 
     name = "fhosted"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="project",
             label="Project",
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 8b9aab3..6961d4a 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -17,7 +17,7 @@ class GitHubPRs(Widget):
 
     name = "github_pr"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="organization",
             label="Organization",
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index 6af020d..e29faa7 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -11,7 +11,7 @@ class GitHubIssues(Widget):
 
     name = "githubissues"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="org",
             label="Username",
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index d15fa1d..351ec4f 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -9,7 +9,7 @@ class Library(Widget):
 
     name = "library"
     position = "both"
-    arguments = [dict(
+    parameters = [dict(
         name="urls",
         label="URLs",
         default=None,
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index f745e28..dfae632 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -8,7 +8,7 @@ class Linechart(Widget):
 
     name = "linechart"
     position = "left"
-    arguments = [dict(
+    parameters = [dict(
         name="username",
         label="Username",
         default=None,
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index c87df27..01908ce 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -15,7 +15,7 @@ class Meetings(Widget):
 
     name = "meetings"
     position = "both"
-    arguments = [
+    parameters = [
         dict(
             name="calendar",
             label="Calendar",
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 580fece..518d12d 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -13,7 +13,7 @@ class PagurePRs(Widget):
 
     name = "pagure_pr"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="repo",
             label="Repository",
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index f3490c9..356d59f 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -13,7 +13,7 @@ class PagureIssues(Widget):
 
     name = "pagureissues"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="repo",
             label="Repository",
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index e4e874c..498e3a8 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -14,7 +14,7 @@ class Rules(Widget):
 
     name = "rules"
     position = "both"
-    arguments = [
+    parameters = [
         dict(
             name="link",
             label="Link",
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 02e7fdf..3f038ba 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -8,7 +8,7 @@ class Sticky(Widget):
 
     name = "sticky"
     position = "both"
-    arguments = [
+    parameters = [
         dict(
             name="text",
             label="Text",
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index 14538f0..1641191 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -17,7 +17,7 @@ class Subscriptions(Widget):
 
     name = "subscriptions"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="username",
             label="Username",
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 5d891e0..07fd52b 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -12,7 +12,7 @@ class PendingACLs(Widget):
 
     name = "workflow.pendingacls"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="username",
             label="Username",
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index d2490a3..79fac1f 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -16,7 +16,7 @@ class Updates2Stable(Widget):
 
     name = "workflow.updates2stable"
     position = "right"
-    arguments = [
+    parameters = [
         dict(
             name="username",
             label="Username",

